// *****************************************************************
// *                                                               *
// *       Copyright (c) Fast Corporation, 2008                    *
// *                                                               *
// *   All Rights Reserved.  Unpublished rights  reserved  under   *
// *   the copyright laws of the Japan.                            *
// *                                                               *
// *   The software contained on this media  is  proprietary  to   *
// *   and  embodies  the  confidential  technology  of  Fast      *
// *   Corporation.  Possession, use,  duplication  or             *
// *   dissemination of the software and media is authorized only  *
// *   pursuant to a valid written license from Fast Corporation.  *
// *                                                               *
// *****************************************************************

// -------------------------------------------------------------------
// FVX Sample Program
// 
//
// 쐬 : R.Nagashima
//    : 2008/05/22 
//
//-------------------------------------------------------------------
using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.Text;
using System.Windows.Forms;
using FVDATASLib;

namespace Blob2
{
    public partial class frmBlobResult : Form
    {
        public frmBlobResult()
        {
            InitializeComponent();
        }

        public int m_BlobNo = -1;//ݕ\Ău[uԍ
        public int m_MaxBlobNo  = 0;//Su[u
        public frmMain m_owner;
        private const double PI = 3.14159265358979;
        
        private void frmBlobResult_Load(object sender, EventArgs e)
        {
            int Area = 0;
            int MaxArea = -1;
            int MaxAreaIndex = -1;

            m_owner = (frmMain)this.Owner;//etH[

            for (int i = 0; i < m_MaxBlobNo; i++)
            {
                Area = m_owner.axFvxBlob1.GetResultArea(i);
                if (MaxArea < Area)
                {
                    MaxArea = Area;
                    MaxAreaIndex = i;
                }
            }
            if (-1 != MaxAreaIndex)
            {
                m_BlobNo = m_owner.axFvxBlob1.GetBlobNo(MaxAreaIndex);
                DrawOneFromBlobNo(m_BlobNo);
            }
        }

        //I
        private void btnExitform_Click(object sender, EventArgs e)
        {
            this.Close();
        }

        //1Blob`
        private void DrawOneFromBlobNo(int Num)
        {
            FvBlobResult BlobResult = new FvBlobResult();
            FvLine Line = new FvLine();
            FvEllipse Ellipse = new FvEllipse();//ȉ~f[^
            double dblAngle;

            txtBlobNo.Text = Num.ToString();

            //I[o[Cʂ̏
            m_owner.axFvxDisplayEx1.ClearOverlay(-1);

            //͈͂ŕ\
            m_owner.axFvxDisplayEx1.PenColor = System.Drawing.Color.Blue;
            m_owner.axFvxDisplayEx1.DrawData( 0,m_owner.m_ExeRegion );

            //u[uڍ׏擾
            m_owner.axFvxBlob1.GetResultFromBlobNo( Num, BlobResult );

            //u[ȕڍׂȏeLXg{bNXɕ\
            txtResult.Text = string.Format( "u[uԍ : {0:0}\r\n" +
                                            "܂܂Ȃʐ : {1:0}\r\n" + 
                                            " : {2:0}\r\n" +
                                            "͒ : {3:0}\r\n" +
                                            "ȉ~厲 : {4:0.00}\r\n" +
                                            "ȉ~ : {5:0.00}\r\n" +
                                            "ȉ~XΊp : {6:0.00}\r\n" +
                                            "dSW : ( {7:0.00} , {8:0.00} )\r\n" +
                                            "Xŏl : {9:0}\r\n" +
                                            "Xől : {10:0}\r\n" +
                                            "Yŏl : {11:0}\r\n" +
                                            "Yől : {12:0}\r\n" +
                                            "܂߂ʐ : {13:0}\r\n" +
                                            "Oڒ`@ : ( {14:0.00} , {15:0.00} )\r\n" +
                                            "Oڒ`@E : ( {16:0.00} , {17:0.00} )\r\n" +
                                            "Oڒ`@ : ( {18:0.00} , {19:0.00} )\r\n" +
                                            "Oڒ`@E : ( {20:0.00} , {21:0.00} )\r\n",
                                            BlobResult.blob_no,
                                            BlobResult.area,
                                            BlobResult.hole_num,
                                            BlobResult.perim,
                                            BlobResult.ellipse_long,
                                            BlobResult.ellipse_short,
                                            BlobResult.ellipse_angle,
                                            BlobResult.center_x,
                                            BlobResult.center_y,
                                            BlobResult.x_min,
                                            BlobResult.x_max,
                                            BlobResult.y_min,
                                            BlobResult.y_max,
                                            BlobResult.total_area,
                                            BlobResult.bounding_top_x,
                                            BlobResult.bounding_top_y,
                                            BlobResult.bounding_right_x,
                                            BlobResult.bounding_right_y,
                                            BlobResult.bounding_left_x,
                                            BlobResult.bounding_left_y,
                                            BlobResult.bounding_bottom_x,
                                            BlobResult.bounding_bottom_y);
            //
            m_owner.axFvxDisplayEx1.PenColor = System.Drawing.Color.Green;

            //ȉ~\
            Ellipse.angle = BlobResult.ellipse_angle;
            Ellipse.axis_x = BlobResult.ellipse_long;
            Ellipse.axis_y = BlobResult.ellipse_short;
            Ellipse.x = BlobResult.center_x;
            Ellipse.y = BlobResult.center_y;
            m_owner.axFvxDisplayEx1.DrawData(0, Ellipse);

            //dSʂAȉ~̒yђZ̒
            //dS_ : ( X1, y1 )  ȉ~XΊp : ƂƂƁA̎
            // - xsin + ycos + ( x1sin - y1cos ) = 0
            dblAngle = BlobResult.ellipse_angle * PI / 180;
            Line.a = -System.Math.Sin( dblAngle );
            Line.b = System.Math.Cos(dblAngle);
            Line.c = (BlobResult.center_x * System.Math.Sin(dblAngle)) - (BlobResult.center_y * System.Math.Cos(dblAngle));
            m_owner.axFvxDisplayEx1.DrawData(0, Line);

            dblAngle = (BlobResult.ellipse_angle + 90) * PI / 180;
            Line.a = -System.Math.Sin(dblAngle);
            Line.b = System.Math.Cos(dblAngle);
            Line.c = (BlobResult.center_x * System.Math.Sin(dblAngle)) - (BlobResult.center_y * System.Math.Cos(dblAngle));
            m_owner.axFvxDisplayEx1.DrawData(0, Line);
            
            //dS_ƊOڒ`̕`
            m_owner.axFvxDisplayEx1.DrawData(0, BlobResult);
        }

        //eBlob
        private void btnParentBlob_Click(object sender, EventArgs e)
        {
            int ParentBlobNo;
            FvBlobResult BlobResult = new FvBlobResult();

            ParentBlobNo = m_owner.axFvxBlob1.GetParentFromBlobNo(m_BlobNo);
            if (-1 != ParentBlobNo)
            {
                DrawOneFromBlobNo(ParentBlobNo);
                m_BlobNo = ParentBlobNo;
            }
        }

        //qBlob
        private void btnChildBlob_Click(object sender, EventArgs e)
        {
            int ChildBlobNo;
            FvBlobResult BlobResult = new FvBlobResult();

            ChildBlobNo = m_owner.axFvxBlob1.GetChildFromBlobNo( m_BlobNo );
            if ( -1 != ChildBlobNo )
            {
                DrawOneFromBlobNo( ChildBlobNo );
                m_BlobNo = ChildBlobNo;
            }
        }

        //ZBolb
        private void btnSiblingBlob_Click(object sender, EventArgs e)
        {
            int SiblingBlobNo;
            FvBlobResult BlobResult = new FvBlobResult();

            SiblingBlobNo = m_owner.axFvxBlob1.GetSiblingFromBlobNo( m_BlobNo );
            if ( -1 != SiblingBlobNo )
            {
                DrawOneFromBlobNo( SiblingBlobNo );
                m_BlobNo = SiblingBlobNo;
            }
        }

        //Periphry
        private void btnPeriphry_Click(object sender, EventArgs e)
        {
            FvPointGroup PointGroup = new FvPointGroup();
            FvPoint Point = new FvPoint();
            String Str = "";
            int i;

            try
            {
                //wu[ũGA͍W擾
                m_owner.axFvxBlob1.GetResultPeriphryFromBlobNo(m_owner.axFvxImageBin.GetOcx(), m_BlobNo,PointGroup,FVXCOMBLOBLib.BLOB_VECTOR_TYPE.BLOB_VECTOR_OFF);
                for ( i = 0; i < PointGroup.Count - 1; i++ )
                {
                    Point = PointGroup.Item2( i );
                    Str = Str + string.Format( "[{0:0}](x,y) = ({1:0.0},{2:0.0})\r\n",i,Point.x,Point.y);
                }
                Str = Str + "\r\n";

                txtResult.Text = txtResult.Text + Str;

                m_owner.axFvxDisplayEx1.PenColor = System.Drawing.Color.Red;
                m_owner.axFvxDisplayEx1.DrawData( 1, PointGroup );
                m_owner.axFvxDisplayEx1.PenColor = System.Drawing.Color.Blue;
            }
            catch ( Exception )
            {
                int IntErr = 0;
                m_owner.axFvxBlob1.GetErrReport( out IntErr );
                MessageBox.Show( "PeriphryF͒̌vłȂu[ułFErrorCode=" + IntErr.ToString(),"Error" );
                return;
            }
         }

        //Blob Paint
        private void btnBlobPaint_Click(object sender, EventArgs e)
        {
            FvBlobResult BlobResult = new FvBlobResult();

            try
            {
                //u[uڍ׏擾
                m_owner.axFvxBlob1.GetResultFromBlobNo( m_BlobNo, BlobResult );

                if ( BlobResult.color == 0 )
                    m_owner.axFvxBlob1.BlobPaintFromBlobNo( m_owner.axFvxImageBin.GetOcx(), m_BlobNo, FVXCOMBLOBLib.COLOR_TYPE.WHITE_COLOR );
                else
                    m_owner.axFvxBlob1.BlobPaintFromBlobNo( m_owner.axFvxImageBin.GetOcx(), m_BlobNo, FVXCOMBLOBLib.COLOR_TYPE.BLACK_COLOR );

                m_owner.axFvxDisplayEx1.DrawImage( m_owner.axFvxImageBin.GetOcx() );
            }
            catch ( Exception )
            {
                int IntErr = 0;
                m_owner.axFvxBlob1.GetErrReport( out IntErr );
                MessageBox.Show( "ErrorCode=" + IntErr.ToString(), "Error" );
                return;
            }
        }

    }
}